//+------------------------------------------------------------------+
//|                                                Complex_pairs.mq4 |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//|                 http://forum.alpari-idc.ru/viewtopic.php?t=46916 |
//+------------------------------------------------------------------+
#property copyright "SemSemFX@rambler.ru"
#property link      "http://onix-trade.net/forum/index.php?showtopic=107"
#property link      "http://forum.alpari-idc.ru/viewtopic.php?t=46916"
//----
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  DarkSlateGray
#property indicator_color4  Yellow

extern int    per2         = 0;
extern int    per1         = 0;
extern int    Mode         = 3;
extern int    SignalPeriod = 7;
extern int    SignalMaMode = MODE_LWMA;

double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[]; 
double     csMa[];
double     trend[];

//---- parameters
// for monthly
int mn_per=50;
int mn_fast=1;
// for weekly
int w_per=50;
int w_fast=1;
// for daily 
int d_per=50;
int d_fast=1;
// for H4      
int h4_per=50;    
int h4_fast=1;
// for H1
int h1_per=50;
int h1_fast=1;
// for M30
int m30_per=50;
int m30_fast=1;
// for M15
int m15_per=50;
int m15_fast=1;
// for M5
int m5_per=50;
int m5_fast=1;
// for M1
int m1_per=50;
int m1_fast=1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtBuffer0);
   SetIndexBuffer(3,csMa);
   SetIndexBuffer(4,trend);
   
   switch(Period())
     {
      case 1:     per1=m1_per; per2=m1_fast; break;
      case 5:     per1=m5_per; per2=m5_fast; break;
      case 15:    per1=m15_per;per2=m15_fast; break;
      case 30:    per1=m30_per;per2=m30_fast; break;
      case 60:    per1=h1_per; per2=h1_fast; break;
      case 240:   per1=h4_per; per2=h4_fast; break;
      case 1440:  per1=d_per;  per2=d_fast; break;
      case 10080: per1=w_per;  per2=w_fast; break;
      case 43200: per1=mn_per; per2=mn_fast; break;
     }
   IndicatorShortName(Symbol() + "(" + Period() + "): ");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  int counted_bars=IndicatorCounted();
   int i,limit;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
       double OPEN  = iMA(NULL,0,per2,0,Mode,PRICE_OPEN, i) - iMA(NULL,0,per1,0,Mode,PRICE_OPEN, i);
       double HIGH  = iMA(NULL,0,per2,0,Mode,PRICE_HIGH, i) - iMA(NULL,0,per1,0,Mode,PRICE_HIGH, i);
       double LOW   = iMA(NULL,0,per2,0,Mode,PRICE_LOW,  i) - iMA(NULL,0,per1,0,Mode,PRICE_LOW,  i);
       double CLOSE = iMA(NULL,0,per2,0,Mode,PRICE_CLOSE,i) - iMA(NULL,0,per1,0,Mode,PRICE_CLOSE,i);
          
             if (HIGH + LOW != 0)
                   ExtBuffer0[i] = (OPEN+HIGH+LOW+CLOSE)/4;
             else  ExtBuffer0[i] = 0;
       
             ExtBuffer1[i] = EMPTY_VALUE;
             ExtBuffer2[i] = EMPTY_VALUE;
             trend[i] = trend[i+1];
             
             //
             //
             //
             //
             //
             
             if (ExtBuffer0[i]>0) trend[i] = 1;
             if (ExtBuffer0[i]<0) trend[i] =-1; 
             if (trend[i] == 1)   ExtBuffer1[i]=ExtBuffer0[i]; 
             if (trend[i] ==-1)   ExtBuffer2[i]=ExtBuffer0[i]; 
           
        }
   for (i=limit; i>=0; i--) csMa[i] = iMAOnArray(ExtBuffer0,0,SignalPeriod,0,SignalMaMode,i);
   return(0);
  }//+------------------------------------------------------------------+